/*
 * Fernando Pereira Silveira
 */

var controledescripts = {

	adicionarEvento: function()
	{
		if (this.listaDisponiveis.selectedItem)
		{
			var lower = this.listaDisponiveis.selectedItem.getAttribute("label").toLowerCase();

			if (!estaNaLista(lower, this.eventosValidos))
			{
				this.eventosValidos.push(lower);
				this.eventosValidos = this.eventosValidos.sort();
				this.carregarEventos(true);
			}
			else
				alert(this.stringset.getString("controledescripts.eventOnList"));
		}
	},

	atualizarBotoes: function()
	{
		if (this.listaDisponiveis.selectedItem)
			this.botaoAdicionarEvento.disabled = false;
		else
			this.botaoAdicionarEvento.disabled = true;

		if (this.listaPermitidos.selectedItem)
			this.botaoRemoverEvento.disabled = false;
		else
			this.botaoRemoverEvento.disabled = true;
	},

	atualizarCaixa: function()
	{
		this.caixaIcones.disabled = this.caixaFerramentas.checked;
	},

	carregarCaixas: function()
	{
		var caixas   = document.getElementsByTagName("checkbox");
		var inversas = document.getElementsByAttribute("reversed", "true");

		for (var indice=0; indice < caixas.length; indice++)
			if (estaNaLista(caixas[indice], inversas))
				caixas[indice].checked = !obterBooleana(caixas[indice].getAttribute("prefstring"));
			else
				caixas[indice].checked =  obterBooleana(caixas[indice].getAttribute("prefstring"));

		this.atualizarCaixa();
	},

	carregarEventos: function(recarga)
	{
		var indice;

		if (recarga)
			for (indice=0; indice < this.tamanhoAnteriorEventos; indice++)
				if (this.listaPermitidos.hasChildNodes)
					this.listaPermitidos.removeChild(this.listaPermitidos.lastChild);

		for (indice in this.eventosValidos)
			this.listaPermitidos.appendItem(this.eventosValidos[indice]);

		this.tamanhoAnteriorEventos = this.eventosValidos.length;
		this.atualizarBotoes();
	},

	iniciar: function()
	{
		this.iniciarItens();

		this.eventosValidos = obterString("dom.popup_allowed_events").split(" ");

		if (listaEstaVazia(this.eventosValidos))
			this.eventosValidos.splice(0, 1);
	
		this.tamanhoAnteriorEventos = this.eventosValidos.length;

		this.carregarCaixas();
		this.carregarEventos(false);
	},

	iniciarItens: function()
	{
		this.botaoAdicionarEvento = document.getElementById("controledescripts-eventos-adicionar");
		this.botaoRemoverEvento   = document.getElementById("controledescripts-eventos-remover");
		this.caixaFerramentas     = document.getElementById("controledescripts-ocultarmenu");
		this.caixaIcones          = document.getElementById("controledescripts-exibiricones");
		this.listaDisponiveis     = document.getElementById("controledescripts-eventos-disponiveis");
		this.listaPermitidos      = document.getElementById("controledescripts-eventos-permitidos");
		this.stringset            = document.getElementById("controledescripts-strings-prefs");
	},

	removerEvento: function()
	{
		if (this.listaPermitidos.selectedItem)
		{
			var indice = posicaoNaLista(this.listaPermitidos.selectedItem.getAttribute("label"), this.eventosValidos);

			this.eventosValidos.splice(indice, 1);
			this.carregarEventos(true);
		}
	},

	salvar: function()
	{
		this.salvarCaixas();

		salvarString("dom.popup_allowed_events", this.eventosValidos.join(" "));
	},

	salvarCaixas: function()
	{
		var caixas   = document.getElementsByTagName("checkbox");
		var inversas = document.getElementsByAttribute("reversed", "true");

		for (var indice=0; indice < caixas.length; indice++)
			if (estaNaLista(caixas[indice], inversas))
				salvarBooleana(caixas[indice].getAttribute("prefstring"),!caixas[indice].checked);
			else
				salvarBooleana(caixas[indice].getAttribute("prefstring"), caixas[indice].checked);
	},

	sobreEvento: function()
	{
		if (this.listaDisponiveis.selectedItem)
			window.openDialog("chrome://controledescripts/content/evento.xul", "controledescripts-sobre", "chrome,centerscreen,modal",this.listaDisponiveis.selectedItem.getAttribute("label"));
	}
}
